<?/*
+-------------------------------------------------------------------------+
| Discover.php - Version 0.1b                                                                        |
|                                                                         |
| Copyright (C) 2003 Jim Lancaster                                        |
|                                                                         |
| This program is free software; you can redistribute it and/or           |
| modify it under the terms of the GNU General Public License             |
| as published by the Free Software Foundation; either version 2          |
| of the License, or (at your option) any later version.                  |
|                                                                         |
| This program is distributed in the hope that it will be useful,         |
| but WITHOUT ANY WARRANTY; without even the implied warranty of          |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
| GNU General Public License for more details.                            |
+-------------------------------------------------------------------------+
| cacti: the rrdtool frontend [php-auth, php-tree, php-form]              |
+-------------------------------------------------------------------------+
| This code is an extension to cacti 0.6.8a which was developed           |
| by Ian Berry.  Any questions or comments regarding this extension       |
| should be directed to:                                                  |
| - jlancaster@mbdworld.com                                               |                                                     |
+-------------------------------------------------------------------------+
| - raXnet - http://www.raxnet.net/                                       |
+-------------------------------------------------------------------------+
*/?>
<?  $section = "Add/Edit Data Sources"; include ('include/auth.php');
    header("Cache-control: no-cache");
    include_once ('include/functions.php');
    include_once ('include/utility_functions.php');
    include ('include/database.php');
    include ('include/config.php');
    include_once ('include/form.php');

    $current_script_name = basename($HTTP_SERVER_VARS["SCRIPT_NAME"]);

switch ($action) {
    case 'save':
        if ($id) {
            $sql_id = mysql_query("replace into discover_hosts (id,ipaddress,name,type,snmp,
                snmp_community,snmp_port,wmi,script) values ($id,\"$ipaddress\",\"$name\",\"$type\",
                \"$snmp\",\"$snmp_community\",\"$snmp_port\",\"$wmi\",\"$script\")",$cnn_id);

        }

        header ("Location: discover.php");
        break;

    case 'edit':
        include_once ('include/top_header.php');

        /* Pull up the existing record information */
        if ($id) {
            $sql_id = mysql_query("select * from discover_hosts where id=$id", $cnn_id);

            DrawFormHeader("Edit the Discovered Host","",false);
            DrawFormItem("IP address","");
            DrawFormItemTextBox("ipaddress",$sql_id,"","15");
            DrawFormItem("Host name","");
            DrawFormItemTextBox("name",$sql_id,"","25");
            DrawFormItem("Host type","This dictates the the perl script that will be used to poll the device.");
            DrawFormItemTextBox("type",$sql_id,"","15");
            DrawFormItem("SNMP","Whether or not SNMP is enabled (snmp/nosnmp).");
            DrawFormItemTextBox("snmp",$sql_id,"","15");
            DrawFormItem("SNMP read community string","(default = public)");
            DrawFormItemTextBox("snmp_community",$sql_id,"","15");
            DrawFormItem("SNMP port","(default = 161)");
            DrawFormItemTextBox("snmp_port",$sql_id,"","15");
            DrawFormItem("WMI","Whether or not WMI is enabled (wmi/nowmi). This applies to Windows NT4/2K/XP only.");
            DrawFormItemTextBox("wmi",$sql_id,"","15");
            DrawFormItem("Script name","Perl script used to poll the device.");
            DrawFormItemTextBox("script",$sql_id,"","15");

            DrawFormItemHiddenTextBox("id",$id,"0");
            DrawFormSaveButton();
            DrawFormFooter();

        }

        include_once ("include/bottom_footer.php");
        break;

    case 'discover':
        include_once ('include/top_header.php');

        /* If the subnet is not already defined, prompt the user for it. */
        if (!$subnet) {

            DrawFormHeader("Discover","",false);
            DrawFormItem("Subnet","Enter the subnet to be scanned in 0.0.0.0/0 format. (Valid masks = 24-31)");
            DrawFormItemTextBox("subnet","","","20");
            DrawFormItem("","Be patient after submitting. The discovery takes about 1 sec per host.");
            DrawFormSubmitButton();

        /* Run the discover script */
        } else {

            DrawFormHeader("Discover Results","",false);
            $cmd="cmd.exe /c \"c:\\perl\\bin\\perl scripts\\discover.pl -i=".$subnet." -c\"";
            $result .= $cmd."<br>";
            $handle = popen($cmd,"rb");
            while (!feof ($handle)) {
                $buffer = fgets($handle,64);
                $result .= $buffer;
            }
            pclose($handle);
            DrawFormPreformatedText($color_panel,$result);

        }

        include_once ("include/bottom_footer.php");
        break;

    case 'create':
        include_once ('include/top_header.php');

        if ($id != "") {
            $sql_id = mysql_query("select * from discover_hosts where id=$id", $cnn_id);

            /* Create the DIS, DS, & default graphs */
            DrawFormHeader("Create DIS, DS & Default Graphs","",false);
            $cmd="cmd.exe /c \"c:\\perl\\bin\\perl scripts\\".mysql_result($sql_id,"","script").".pl -i=".mysql_result($sql_id,"","ipaddress")." -c\"";
            $result .= $cmd."<br>";
            $handle = popen($cmd,"rb");
            while (!feof ($handle)) {
                $buffer = fgets($handle,64);
                $result .= $buffer;
            }
            pclose($handle);
            DrawFormPreformatedText($color_panel,$result);

            /* Now delete the host from discover table to prevent recreating the same host */
            mysql_query("delete from discover_hosts where id=$id",$cnn_id);

        }

        include_once ("include/bottom_footer.php");
        break;

    case 'remove':
        if (($config["remove_verification"]["value"] == "on") && ($confirm != "yes")) {
            include_once ('include/top_header.php');
            DrawConfirmForm("Are You Sure?", "Are you sure you want to delete this host?", $current_script_name, "?action=remove&id=$id");
            exit;
        }

        if (($config["remove_verification"]["value"] == "") || ($confirm == "yes")) {
            mysql_query("delete from discover_hosts where id=$id",$cnn_id);
        }

        header ("Location: " . $current_script_name);
        break;

    default:
        include_once ('include/top_header.php');

        DrawMatrixTableBegin("97%");
        DrawMatrixRowBegin();
            DrawMatrixHeaderTop("Discovered Hosts",$color_dark_bar,"","6");
            DrawMatrixLoopItemAction("Create all",$color_dark_bar,"",true,$current_script_name . "?action=createall");
            DrawMatrixLoopItemAction("Discover",$color_dark_bar,"",true,$current_script_name . "?action=discover");
        DrawMatrixRowEnd();

        DrawMatrixRowBegin();
            DrawMatrixHeaderItem("IP Address",$color_panel,$color_panel_text);
            DrawMatrixHeaderItem("Name",$color_panel,$color_panel_text);
            DrawMatrixHeaderItem("Type",$color_panel,$color_panel_text);
            DrawMatrixHeaderItem("SNMP",$color_panel,$color_panel_text);
            DrawMatrixHeaderItem("WMI",$color_panel,$color_panel_text);
            DrawMatrixHeaderItem("Script",$color_panel,$color_panel_text);
            DrawMatrixHeaderItem("",$color_panel,$color_panel_text);
            DrawMatrixHeaderItem("",$color_panel,$color_panel_text);
        DrawMatrixRowEnd();

        $sql_id = mysql_query("select * from discover_hosts order by type,name", $cnn_id);
        $rows = mysql_num_rows($sql_id);
        $i = 0;

        while ($i < $rows) {
            DrawMatrixRowAlternateColorBegin($color_alternate,$color_light,$i);
                DrawMatrixLoopItem($sql_id,"ipaddress",$i,false,"");
                DrawMatrixLoopItem($sql_id,"name",$i,html_boolean($config["vis_main_column_bold"]["value"]),$current_script_name . "?action=edit&id=" . mysql_result($sql_id, $i, "id"));
                DrawMatrixLoopItem($sql_id,"type",$i,false,"");
                DrawMatrixLoopItem($sql_id,"snmp",$i,false,"");
                DrawMatrixLoopItem($sql_id,"wmi",$i,false,"");
                DrawMatrixLoopItem($sql_id,"script",$i,false,"");
                DrawMatrixLoopItemAction("Create",$color_panel,"",false,$current_script_name . "?action=create&id=" . mysql_result($sql_id,$i,"id"));
                DrawMatrixLoopItemAction("Remove",$color_panel,"",false,$current_script_name . "?action=remove&id=" . mysql_result($sql_id,$i,"id"));
            DrawMatrixRowEnd();
            $i++;
        }

        DrawMatrixTableEnd();
        include_once ("include/bottom_footer.php");

        break;
}

/* draws a vertical space and a 'submit' button, then ends the form. */
function DrawFormSubmitButton() { ?>
    <tr height="5"><td>&nbsp;</td></tr>
    <tr>
        <td>
            &nbsp;&nbsp;&nbsp;<input type="submit" value="Submit">
        </td>
    </tr>
</form>
</table>
</body>
</html>
<?}

?>
